#include <stdio.h>
#include <dos.h>
#define  CBS 256
unsigned char c;
long speed;

char buffe1[CBS], *inpt1, *outpt1, dis8251;
int  dat8251, com8251, stat8251, c_in_bu1, modemctr1, modemsta1, int1;

main(ac,av)
int ac; char *av[];
{
  int i1,i2,k;
  speed=9600;
  if(ac>1)sscanf(av[1],"%ld",&speed);
  c_in_bu1=0;
  comm_open(speed);
  system("cls");
  printf("\t\t\tUsage: ncom1 [baud] ( %ld )\n",speed);
l10:
  c=keyin();
  if(c==27){ comm_close(); exit(); }

  if(c!=255 )comm_p1(c);
  if(c_in_bu1){
    c=comm_getc1();    crt(c);
    if(c==13)crt(10);
    if(c==10)crt(13);
  }
  goto l10;
}

wpos(int x, int y)
{
  asm mov dh,x
  asm mov dl,y
  asm mov bh,0
  asm mov ah,2
  asm int 10h
}

keyin()
{
  asm mov ah,6
  asm mov dl,0ffh
  asm int 21h
  asm mov cx,0ffffh
  asm jz keyin1
  asm mov ah,0
  asm mov cx,ax
keyin1:
  return (_CX);
}

crt(int k)
{
  asm mov ax,k
  asm mov ah,14
  asm mov bx,0
  asm int 10h
}

void interrupt ( far *oldve1 ) ();
void interrupt serin1 ()
{
  *inpt1++ = inportb( dat8251 );
  c_in_bu1++;
  asm cli
  if (inpt1 == &buffe1[CBS] ) inpt1=buffe1;
  asm sti
  outportb( 0x20,0x20);
}

comm_open ( long speed )
{
  int k;
  int en8251;
    int1    = 0x0C;       
    en8251  = 0xEF;

  dat8251    = 0x3f8;       /* 3f8, if com1 */
  com8251    = 0x3fb; 
  modemctr1  = 0x3fc;
  stat8251   = 0x3fd;
  modemsta1  = 0x3fe;
/*  k=inportb( 0x3fb);  */
  outportb ( 0x3fb, 0x80 );  /* set baud enable */
  outportb ( 0x3f8, 12);   /* 9600 baud */
  outportb ( 0x3f9, 0);
/*  outportb ( 0x3fb, k );  recover */
  inpt1 = outpt1 = buffe1;
  oldve1 = getvect ( int1 );       /* Save old int vector */
  setvect  ( int1, serin1 );

  outportb ( 0x3fb, 0x3 );  /* 8bits no parity */
  outportb ( 0x3fc, 0xb );  /* or 3; ?? +  DTR+RTS output enable */
  inportb  ( 0x3f8 );              /* read a dummy */
  outportb ( 0x3f9, 0x1 );  /*or 3 interupt: Receiver-Data-Ready int */
  outportb ( 0x21,en8251 & inportb(0x21) );  /* Enable 8259 interrupts */
}

comm_close ()
{
  outportb ( com8251 + 1, 0x08 );
  outportb ( com8251 + 1, 0x00 );
  outportb ( 0x21, dis8251 | inportb ( 0x21 ) );
  setvect ( int1, oldve1 );
}

comm_getc1( )                   /* if buf_not_empty, read a char from buf */
{
  int c;
  char * ptr;
  ptr = outpt1;
  c = *ptr++;
  if ( ptr == &buffe1[CBS] )  ptr = buffe1;
  asm cli
  outpt1 = ptr;
  c_in_bu1--;
  asm sti
  return ( c );
}

comm_p1(int k)                   /* trans a char */
{
l10:
  if(keyin()==27)return;
  if((inportb(stat8251)&0x20)==0)goto l10;
  outportb(dat8251,k);
}
